﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
#Event: TextChanged (OldText As String, Newtext As String)
#Event: FocusChanged (HasFocus As Boolean)
#Event: EnterPressed

#DesignerProperty: Key: Hint, DisplayName: Hint label, FieldType: String, DefaultValue: Hint, Description: Hint Label
#DesignerProperty: Key: HintTextColor, DisplayName: Color Hint, FieldType: Color, DefaultValue: 0xFF6495ED, Description: Hint Text color
#DesignerProperty: Key: HintBackGroundColor, DisplayName: BackGroundColor Hint, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Hint BackGround color
#DesignerProperty: Key: Animated, DisplayName: Animated Hint, FieldType: Boolean, DefaultValue: True, Description: Hint Animated
#DesignerProperty: Key: RTL, DisplayName: Right to Left, FieldType: Boolean, DefaultValue: False, Description: Write Right to Left
#DesignerProperty: Key: Corner, DisplayName: Rounded Corner, FieldType: Int, DefaultValue: 5, MinRange: 0, MaxRange: 50, Description: Rounded corner
#DesignerProperty: Key: CornerColor, DisplayName: CornerColor Color, FieldType: Color, DefaultValue: 0xFF000000, Description: CornerColor color
#DesignerProperty: Key: Password, DisplayName: Password, FieldType: Boolean, DefaultValue: False, Description: Hide text for password
#DesignerProperty: Key: Editable, DisplayName: Editable, FieldType: Boolean, DefaultValue: True, Description: Field Editable

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Private HintTextSize As Int
	Private LabelHint As B4XView
	Private MyEditText As B4XView
	
	Private RTL As Boolean = False
	Private HintReduce As Boolean = True
	Private Animated As Boolean = True
	Private CornerColor As Int
	Private Corner As Int
	Private Pss As Boolean = False
	Private FieldEditable As Boolean
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	Dim LH As Label
	LH.Initialize("LabelHint")
	LabelHint=LH
	
	FieldEditable=True
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 	
	Dim lbx As B4XView = Lbl
	
	If Props.ContainsKey("Editable") Then FieldEditable=Props.Get("Editable")
	
	#IF B4A
		Dim ED As EditText
		ED.Initialize("MyEditText")
		If Props.ContainsKey("Password") Then 
			If Props.Get("Password").As(Boolean) Then ED.InputType=Bit.Or(ED.InputType, 0x00000080)
		End If
		If FieldEditable=False Then ED.InputType=ED.INPUT_TYPE_NONE
		MyEditText=ED
	#ELSE IF B4i
		If  Not(FieldEditable) Then
			Dim La As Label
			La.Initialize("MyEditText")
			MyEditText=La
		Else
			Dim ED As TextField
			ED.Initialize("MyEditText")
			If Props.ContainsKey("Password") Then
				If Props.Get("Password") Then ED.PasswordMode=True
			End If
			MyEditText=ED
		End If

	#ELSE IF B4J
		If FieldEditable Then 
			Dim ED As TextField
			If Props.ContainsKey("Password") Then
			Pss=Props.Get("Password")
				If Props.Get("Password") Then
					ED.InitializePassword("MyEditText")
				Else
					ED.Initialize("MyEditText")
				End If
			End If
			MyEditText=ED
		Else
			Dim EDl As Label
			EDl.Initialize("MyEditText")		
			MyEditText=EDl
		End If
	#End If
	MyEditText.Tag=Tag
	
	#IF B4J
		Dim Pn As Pane = mBase
		Pn.Style=$"-fx-font-size:14.00;-fx-background-color:#${Bit.ToHexString(Bit.And(mBase.Color,0xFFFFFF))};-fx-border-color:#000000;-fx-border-width:0.00;-fx-border-radius:$1.2{20dip};-fx-background-radius:$1.2{20dip};-fx-border-width:0.00;"$
	#End If
	
	If Props.ContainsKey("CornerColor") Then
		CornerColor=xui.PaintOrColorToColor(Props.Get("CornerColor"))
	Else
		CornerColor=lbx.TextColor
	End If
	
	If Props.ContainsKey("Corner") Then
		Corner=Props.Get("Corner")
		Corner=Corner*(100dip/100)
	Else
		Corner=20dip
	End If
	
	MyEditText.Text=lbx.Text
	MyEditText.TextColor=lbx.TextColor
	MyEditText.TextSize=lbx.TextSize
	MyEditText.Font=lbx.Font

	Try
		Log(mBase.Color)
	Catch
		mBase.Color=xui.Color_Transparent
	End Try
	MyEditText.SetColorAndBorder(mBase.Color,1dip,CornerColor,Corner)
	
	LabelHint.Text=Props.Get("Hint")
	LabelHint.TextColor=xui.PaintOrColorToColor(Props.Get("HintTextColor"))
	LabelHint.SetColorAndBorder(xui.PaintOrColorToColor(Props.Get("HintBackGroundColor")),0dip,xui.Color_Transparent,15dip)
	LabelHint.SetTextAlignment("CENTER","CENTER")
	HintTextSize=MyEditText.TextSize-2
	Animated=Props.Get("Animated")
	
	If Props.ContainsKey("RTL") Then RTL=Props.Get("RTL")
	mBase.Color=xui.Color_Transparent
	Direction
	
	#If B4i
		mBase.AddView(MyEditText,0dip,15dip,mBase.Width-6dip,mBase.Height-17dip)
	#ELSE IF B4A
		mBase.AddView(MyEditText,0dip,15dip,mBase.Width-5dip,mBase.Height-15dip)
	#ELSE IF B4j
		mBase.AddView(MyEditText,0dip,15dip,mBase.Width-5dip,mBase.Height-15dip)
	#End If

	mBase.AddView(LabelHint,5dip,5dip,mBase.Width-5dip,30dip)
	
	HintReduce=(MyEditText.Text.Length=0)
	HintAnimation((MyEditText.Text.Length>0))
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	#IF B4i
		MyEditText.Width=Width-6dip
		MyEditText.Height=Height-17dip
	#ELSE 
		MyEditText.Width=Width-5dip
		MyEditText.Height=Height-15dip
	#END IF
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

#if B4A
Public Sub getNativeObject As EditText
	Return MyEditText
End Sub
#ELSE 
Public Sub getNativeObject As TextField
	Return MyEditText
End Sub
#END IF

Public Sub setHint(Text As String)
	LabelHint.Text=Text
End Sub

Public Sub getHint As String
	Return LabelHint.Text
End Sub

Public Sub setHintFont(Fnt As B4XFont)
	LabelHint.Font=Fnt
End Sub

Public Sub getHintFont As B4XFont
	Return LabelHint.Font
End Sub

Public Sub setText(Text As String)
	MyEditText.Text=Text
	If Animated Then 
		HintAnimation(True)
		'LabelHint.SetVisibleAnimated(400,(MyEditText.Text.Length>0))
	Else
		HintAnimation(False)
		'LabelHint.SetLayoutAnimated(300,StartLeftHint,20dip,MeasureText,mBase.Height-25dip)
	End If
End Sub

Public Sub getText As String
	Return MyEditText.Text
End Sub

Public Sub setTextFont(Fnt As B4XFont)
	MyEditText.Font=Fnt
End Sub

Public Sub getTextFont As B4XFont
	Return MyEditText.Font
End Sub

Public Sub setAnimateHint(B As Boolean)
	Animated=B
	HintAnimation((MyEditText.Text.Length>0))
End Sub

Public Sub getAnimateHint As Boolean
	Return Animated
End Sub

Public Sub SetTextViewColor(TextColor As Int, BackGroundColor As Int, Corner_Color As Int)
	MyEditText.TextColor=TextColor
	MyEditText.SetColorAndBorder(BackGroundColor,1dip,Corner_Color,Corner)
End Sub

Public Sub SetHintColor(HintTextColor As Int, HintBackGroundColor As Int)
	LabelHint.TextColor=HintTextColor
	LabelHint.SetColorAndBorder(HintBackGroundColor,0dip,xui.Color_Transparent,15dip)
End Sub

#Region Event

Private Sub MyEditText_TextChanged (Old As String, New As String)
	HintAnimation(New.Length>0)
	If xui.SubExists(mCallBack,mEventName & "_TextChanged",2) Then CallSub3(mCallBack,mEventName & "_TextChanged",Old,New)
End Sub

private Sub MyEditText_EnterPressed
	If xui.SubExists(mCallBack,mEventName & "_EnterPressed",0) Then CallSub(mCallBack,mEventName & "_EnterPressed")
End Sub

Private Sub MyEditText_FocusChanged (HasFocus As Boolean)
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSubDelayed2(mCallBack,mEventName & "_FocusChanged",HasFocus)
End Sub

Private Sub MyEditText_BeginEdit
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSubDelayed2(mCallBack,mEventName & "_FocusChanged",True)
End Sub

Private Sub MyEditText_EndEdit
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSubDelayed2(mCallBack,mEventName & "_FocusChanged",False)
End Sub

Private Sub MyEditText_Action
	If xui.SubExists(mCallBack,mEventName & "_EnterPressed",0) Then CallSub(mCallBack,mEventName & "_EnterPressed")
End Sub

Private Sub HintAnimation(NewReduceHint As Boolean)
	Dim StartLeftHint As Int = 15dip

	#if b4a
	If MyEditText.IsInitialized=False Then 
		Sleep(0)
	End If
	#end if
	
	If xui.IsB4J And Pss Then NewReduceHint=False
	If (NewReduceHint<>HintReduce) And (Animated) Then
		If NewReduceHint Then
			LabelHint.TextSize=HintTextSize
			If RTL Then StartLeftHint=mBase.Width-15dip-MeasureText
			LabelHint.SetLayoutAnimated(0,StartLeftHint,20dip,MeasureText,30dip)
			If mBase.Height>50dip Then
				LabelHint.SetLayoutAnimated(300,StartLeftHint,0,MeasureText,30dip)
			Else
				LabelHint.SetLayoutAnimated(300,StartLeftHint,0,MeasureText,mBase.Height*0.6)
			End If
		Else
			LabelHint.TextSize=MyEditText.TextSize
			If RTL Then StartLeftHint=mBase.Width-15dip-MeasureText
			LabelHint.SetLayoutAnimated(300,StartLeftHint,20dip,MeasureText,mBase.Height-25dip)
		End If		
	Else
		LabelHint.TextSize=HintTextSize
		If RTL Then StartLeftHint=mBase.Width-15dip-MeasureText
		If mBase.Height>50dip Then
			LabelHint.SetLayoutAnimated(300,StartLeftHint,0,MeasureText,30dip)
		Else
			LabelHint.SetLayoutAnimated(300,StartLeftHint,0,MeasureText,mBase.Height*0.6)
		End If
	End If
	
	HintReduce=NewReduceHint
End Sub

Private Sub MeasureText As Double
	Dim Pn As B4XView = xui.CreatePanel("")
	Pn.SetLayoutAnimated(0,0,0,mBase.Width,mBase.Height)
	Dim cvs1 As B4XCanvas
	cvs1.Initialize(Pn)
	
	Dim r As B4XRect = cvs1.MeasureText(LabelHint.Text, LabelHint.Font)
	'Return r.Width*1.4
	Return r.Width+16dip
End Sub

Private Sub Direction
	If RTL Then
	#IF B4J
		Dim TF = MyEditText As JavaObject
		TF.RunMethod("setAlignment", Array As Object("CENTER_RIGHT"))
	#ELSE IF B4A
		Dim TF = MyEditText As JavaObject
		TF.RunMethod("setPadding", Array As Object(5dip, 0dip, 5dip, 0dip))
		MyEditText.SetTextAlignment("CENTER","RIGHT")
	#ELSE IF B4i
		MyEditText.SetTextAlignment("CENTER","RIGHT")
	#End If
	Else
	#IF B4J
		Dim TF = MyEditText As JavaObject
		TF.RunMethod("setAlignment", Array As Object("CENTER_LEFT"))
	#ELSE
		MyEditText.SetTextAlignment("CENTER","LEFT")
	#End If
	End If
End Sub

#END Region
