﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
#Event: TextChanged (OldText As String, Newtext As String)
#Event: FocusChanged (HasFocus As Boolean)
#Event: EnterPressed
#Event: Unfocus
#Event: Click
#Event: HintClick

#DesignerProperty: Key: Corner, DisplayName: Rounded Corner, FieldType: Int, DefaultValue: 0, MinRange: 0, MaxRange: 50, Description: Rounded corner
#DesignerProperty: Key: CornerColor, DisplayName: CornerColor Color, FieldType: Color, DefaultValue: 0xFF777777, Description: CornerColor color
#DesignerProperty: Key: Background, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Background color
#DesignerProperty: Key: RTL, DisplayName: Right to Left, FieldType: Boolean, DefaultValue: False, Description: Write Right to Left
#DesignerProperty: Key: Style, DisplayName: View Style, FieldType: String, DefaultValue: Frame, List: Frame|Bead|Diagonal
#DesignerProperty: Key: Password, DisplayName: Password, FieldType: Boolean, DefaultValue: False, Description: Hide text for password
#DesignerProperty: Key: Editable, DisplayName: Editable, FieldType: Boolean, DefaultValue: True, Description: Field Editable

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Dim Can As B4XCanvas

	Private Corner As Int
	Private CornerColor As Int
	Private Textcolor As Int
	Private Style As String = "Frame"
	Private LenEditText As Int = 50dip
	Private BClr As Int
	Private RTL As Boolean = False
	Private LabelHint As B4XView
	Private MyEditText As B4XView
	Private LabelSend As B4XView
	Private FieldEditable As Boolean 
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	FieldEditable=True
	
	Dim LH As Label
	LH.Initialize("LabelHint")
	LabelHint=LH
	
	Dim LS As Label
	LS.Initialize("LabelSend")
	LabelSend=LS
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
	mBase.Tag = Me
	Dim lbx As B4XView = Lbl
	
	If Props.ContainsKey("Editable") Then FieldEditable=Props.Get("Editable")
	
	#IF B4A
		Dim ED As EditText
		ED.Initialize("MyEditText")
		If Props.ContainsKey("Password") Then 
			If Props.Get("Password").As(Boolean) Then ED.InputType=Bit.Or(ED.InputType, 0x00000080)
		End If
		If FieldEditable=False Then ED.InputType=ED.INPUT_TYPE_NONE
		MyEditText=ED
	#ELSE IF B4i
		If  Not(FieldEditable) Then
			Dim La As Label
			La.Initialize("MyEditText")
			MyEditText=La
		Else
			Dim ED As TextField
			ED.Initialize("MyEditText")
			If Props.ContainsKey("Password") Then 
				If Props.Get("Password") Then ED.PasswordMode=True
			End If
			MyEditText=ED
		End If
	#ELSE IF B4J
	If FieldEditable Then 
		Dim ED As TextField
		If Props.ContainsKey("Password") Then
			If Props.Get("Password") Then
				ED.InitializePassword("MyEditText")
			Else
				ED.Initialize("MyEditText")
			End If
		End If
		MyEditText=ED
	Else
		Dim EDl As Label
		EDl.Initialize("MyEditText")
		MyEditText=EDl
	End If
	#End If
	MyEditText.Tag=Tag
	
	Textcolor=lbx.Textcolor
	
	If Props.ContainsKey("RTL") Then RTL=Props.Get("RTL")
	If Props.ContainsKey("Style") Then Style=Props.Get("Style")
	If Props.ContainsKey("CornerColor") Then CornerColor=xui.PaintOrColorToColor(Props.Get("CornerColor")) Else CornerColor=lbx.TextColor
	If Props.ContainsKey("Background") Then	BClr=xui.PaintOrColorToColor(Props.Get("Background")) Else BClr=mBase.Color
	Corner=Props.Get("Corner")
	Corner=Corner*(100dip/100)
	
	#IF B4J
		Dim Pn As Pane = mBase
		Pn.Style="-fx-border-radius:0.00;-fx-background-radius:0.00;-fx-border-width:0.00;"
	#End If
	
	MyEditText.Text=lbx.Text
	MyEditText.TextColor=Textcolor
	MyEditText.TextSize=lbx.TextSize
	MyEditText.Font=lbx.Font
	MyEditText.Color=xui.Color_Transparent

	LabelHint.Text=Chr(0xF183)
	LabelHint.TextColor=Textcolor
	LabelHint.Color=xui.Color_Transparent
	LabelHint.SetTextAlignment("CENTER","CENTER")
	LabelHint.Font=xui.CreateFontAwesome(MyEditText.Font.Size)
		
	LabelSend.Text=Chr(0xF00C) 
	LabelSend.TextColor=Textcolor
	LabelSend.Color=xui.Color_Transparent
	LabelSend.SetTextAlignment("CENTER","CENTER")
	LabelSend.Font=xui.CreateFontAwesome(MyEditText.Font.Size)

	Select Style
		Case "Frame"
			mBase.SetColorAndBorder(BClr,1dip,CornerColor,Corner)
		Case "Bead"
			LenEditText=100dip
			LabelHint.TextColor=BClr
			LabelHint.SetColorAndBorder(CornerColor,0dip,BClr,20dip)
			LabelSend.TextColor=BClr
			LabelSend.SetColorAndBorder(CornerColor,0dip,BClr,20dip)

			Can.Initialize(mBase)
			Background
		Case "Diagonal"
			LabelHint.TextColor=BClr
			LabelSend.TextColor=BClr

			Can.Initialize(mBase)
			BackgroundDiagonal
	End Select
	
	If RTL Then
		mBase.AddView(LabelHint,mBase.Width-45dip,0dip,40dip,mBase.Height)
		mBase.AddView(MyEditText,50dip,0dip,mBase.Width-LenEditText,mBase.Height)
		mBase.AddView(LabelSend,5dip,0dip,40dip,mBase.Height)
		
		#IF B4J
			Dim TF = MyEditText As JavaObject
			TF.RunMethod("setAlignment", Array As Object("CENTER_RIGHT"))
		#ELSE IF B4i
			MyEditText.SetTextAlignment("CENTER","RIGHT")
		#ELSE IF B4A
			MyEditText.SetTextAlignment("CENTER","RIGHT")
			Dim TF = MyEditText As JavaObject
			TF.RunMethod("setPadding", Array As Object(5dip, 0dip, 5dip, 0dip))
		#End If
	Else
		mBase.AddView(LabelHint,5dip,0dip,40dip,mBase.Height)
		mBase.AddView(MyEditText,50dip,0dip,mBase.Width-150dip,mBase.Height)
		mBase.AddView(LabelSend,mBase.Width-45dip,0dip,40dip,mBase.Height)
		#IF B4J
			Dim TF = MyEditText As JavaObject
			TF.RunMethod("setAlignment", Array As Object("CENTER_LEFT"))
		#ELSE
			MyEditText.SetTextAlignment("CENTER","LEFT")
		#End If
	End If
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)	
	If RTL Then
		MyEditText.Width=Width-LenEditText
		MyEditText.Height=Height
		LabelHint.Left=Width-45dip
		LabelHint.Height=Height
		LabelSend.Height=Height
	Else
		MyEditText.Width=Width-LenEditText
		MyEditText.Height=Height
		LabelHint.Height=Height
		LabelSend.Left=Width-45dip
		LabelSend.Height=Height
	End If
	
	mBase.Width=Width
	mBase.Height=Height
	If Style="Bead" Then 
		Background
	else if Style="Diagonal" Then 
		BackgroundDiagonal
	End If
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

#if B4A
Public Sub getNativeObject As EditText
	Return MyEditText
End Sub
#ELSE 
Public Sub getNativeObject As TextField
	Return MyEditText
End Sub
#END IF

Public Sub setHint(Text As String)
	LabelHint.Text=Text
End Sub

Public Sub getHint As String
	Return LabelHint.Text
End Sub

'Char fontAwesone
Public Sub setTextConfirmButton(Text As String)
	LabelSend.Text=Text
End Sub

Public Sub getTextConfirmButton As String
	Return LabelSend.Text
End Sub

Public Sub setHintFont(Fnt As B4XFont)
	LabelHint.Font=Fnt
End Sub

Public Sub getHintFont As B4XFont
	Return LabelHint.Font
End Sub

Public Sub setText(Text As String)
	MyEditText.Text=Text
End Sub

Public Sub getText As String
	Return MyEditText.Text
End Sub

Public Sub setTextFont(Fnt As B4XFont)
	MyEditText.Font=Fnt
End Sub

Public Sub getTextFont As B4XFont
	Return MyEditText.Font
End Sub

#Region Event

Private Sub MyEditText_TextChanged (Old As String, New As String)
	If xui.SubExists(mCallBack,mEventName & "_TextChanged",2) Then CallSub3(mCallBack,mEventName & "_TextChanged",Old,New)
End Sub

private Sub MyEditText_EnterPressed
	If xui.SubExists(mCallBack,mEventName & "_Unfocus",0) Then CallSub(mCallBack,mEventName & "_Unfocus")
	
	If xui.SubExists(mCallBack,mEventName & "_EnterPressed",0) Then CallSub(mCallBack,mEventName & "_EnterPressed")
End Sub

Private Sub MyEditText_FocusChanged (HasFocus As Boolean)
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSub2(mCallBack,mEventName & "_FocusChanged",HasFocus)
End Sub

Private Sub MyEditText_BeginEdit
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSub2(mCallBack,mEventName & "_FocusChanged",True)
End Sub

Private Sub MyEditText_EndEdit
	If xui.SubExists(mCallBack,mEventName & "_Unfocus",0) Then CallSub(mCallBack,mEventName & "_Unfocus")
	
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSub2(mCallBack,mEventName & "_FocusChanged",False)
End Sub

Private Sub MyEditText_Action
	If xui.SubExists(mCallBack,mEventName & "_EnterPressed",0) Then CallSub(mCallBack,mEventName & "_EnterPressed")
End Sub

Private Sub LabelSend_Click
	If xui.SubExists(mCallBack,mEventName & "_Unfocus",0) Then CallSub(mCallBack,mEventName & "_Unfocus")
	
	If xui.SubExists(mCallBack,mEventName & "_Click",0) Then CallSub(mCallBack,mEventName & "_Click")
End Sub

Private Sub LabelHint_Click
	If xui.SubExists(mCallBack,mEventName & "_HintClick",0) Then CallSub(mCallBack,mEventName & "_HintClick")
End Sub

#END Region

Private Sub Background
	Dim Rec As B4XRect
			
	Rec.Initialize(20dip,mBase.Height/2,mBase.Width-20dip,mBase.Height)
	Can.DrawRect(Rec,CornerColor,True,0dip)
		
	Dim Rec As B4XRect
	Rec.Initialize(45dip,0dip,mBase.Width-45dip,mBase.Height-1dip)
	Dim Path As B4XPath
	Path.InitializeRoundedRect(Rec,20dip)
	Can.DrawPath(Path,BClr,True,0dip)
	Can.Invalidate
End Sub

Private Sub BackgroundDiagonal
	Dim Path As B4XPath
	Path.Initialize(mBase.Width,0)
	Path.LineTo(mBase.Width-50dip,0)
	Path.LineTo(mBase.Width-40dip,Can.TargetRect.Height)
	Path.LineTo(mBase.Width,Can.TargetRect.Height)
	Can.DrawPath(Path,CornerColor,True,1dip)
				
	Dim Path As B4XPath
	Path.Initialize(0,0)
	Path.LineTo(40dip,0)
	Path.LineTo(50dip,Can.TargetRect.Height)
	Path.LineTo(0,Can.TargetRect.Height)
	Can.DrawPath(Path,CornerColor,True,1dip)
	
	Can.DrawRect(Can.TargetRect,CornerColor,False,1dip)
	Can.Invalidate
End Sub