﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
#Event: TextChanged (OldText As String, Newtext As String)
#Event: FocusChanged (HasFocus As Boolean)
#Event: EnterPressed
#DesignerProperty: Key: Outline, DisplayName: Outline on start, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: Password, DisplayName: Password, FieldType: Boolean, DefaultValue: False, Description: Hide text for password
#DesignerProperty: Key: Editable, DisplayName: Editable, FieldType: Boolean, DefaultValue: True, Description: Field Editable
''#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Public ExpansionTime As Int = 700
	Private TextView As B4XView
	Private OutLineBase As B4XView
	Private OutLine As B4XView 
	
	Private FieldEditable As Boolean
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback

	OutLine=xui.CreatePanel("")
	OutLineBase=xui.CreatePanel("")
	
	FieldEditable=True
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 
  	''Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props
	Dim xlbl As B4XView = Lbl
	
	If Props.ContainsKey("Editable") Then FieldEditable=Props.Get("Editable")
	
	#IF B4A
		Dim ED As EditText
		ED.Initialize("MyEditText")
		If Props.ContainsKey("Password") Then 
			If Props.Get("Password").As(Boolean) Then ED.InputType=Bit.Or(ED.InputType, 0x00000080)
		End If
		If FieldEditable=False Then ED.InputType=ED.INPUT_TYPE_NONE
		TextView=ED
	#ELSE IF B4i
		If  Not(FieldEditable) Then
			Dim La As Label
			La.Initialize("MyEditText")
			TextView=La
		Else
			Dim ED As TextField
			ED.Initialize("MyEditText")
			If Props.ContainsKey("Password") Then 
				If Props.Get("Password") Then ED.PasswordMode=True
			End If
			TextView=ED
		End If
	#ELSE IF B4J
		If FieldEditable Then 
			Dim ED As TextField
			If Props.ContainsKey("Password") Then
				If Props.Get("Password") Then
					ED.InitializePassword("MyEditText")
				Else
					ED.Initialize("MyEditText")
				End If
				TextView=ED
			End If
		Else
			Dim EDl As Label
			EDl.Initialize("MyEditText")
			TextView=EDl
		End If
	#End If
	TextView.Tag=Tag
	
	TextView.TextColor=xlbl.TextColor
	TextView.Color=xui.Color_Transparent
	
	'mBase.Color=xlbl.color
	mBase.AddView(TextView,0,0,mBase.Width,mBase.Height)
	mBase.AddView(OutLineBase,5dip,mBase.Height-3dip,mBase.Width-10dip,3dip)
	mBase.AddView(OutLine,mBase.Width/2,mBase.Height-3dip,0,3dip)
	OutLineBase.Color=xui.Color_LightGray
	TextView.Text=xlbl.Text
	
	Sleep(400)
	If True=Props.Get("Outline") Then ShowLine
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	TextView.SetLayoutAnimated(0,0,0,Width,Height)
	OutLineBase.SetLayoutAnimated(0,5dip,Height-3dip,Width-10dip,3dip)
	OutLine.SetLayoutAnimated(0,5dip,Height-3dip,Width-10dip,3dip)
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

#if B4A
Public Sub getNativeObject As EditText
	Return TextView
End Sub
#ELSE 
Public Sub getNativeObject As TextField
	Return TextView
End Sub
#END IF

Public Sub setHint(Text As String)
	TextView.Text=Text
End Sub

Public Sub getHint As String
	Return TextView.Text
End Sub

Public Sub setHintFont(Fnt As B4XFont)
	TextView.Font=Fnt
End Sub

Public Sub getHintFont As B4XFont
	Return TextView.Font
End Sub

Public Sub setText(Text As String)
	TextView.Text=Text
End Sub

Public Sub getText As String
	Return TextView.Text
End Sub

Public Sub setTextFont(Fnt As B4XFont)
	TextView.Font=Fnt
End Sub

Public Sub getTextFont As B4XFont
	Return TextView.Font
End Sub

Public Sub UnderLine(Show As Boolean)
	If Show Then ShowLine Else  HideLine
End Sub

#Region Event

Private Sub MyEditText_TextChanged (Old As String, New As String)
	If xui.SubExists(mCallBack,mEventName & "_TextChanged",2) Then CallSub3(mCallBack,mEventName & "_TextChanged",Old,New)
End Sub

private Sub MyEditText_EnterPressed
	If xui.SubExists(mCallBack,mEventName & "_EnterPressed",0) Then CallSub(mCallBack,mEventName & "_EnterPressed")
End Sub

Private Sub MyEditText_FocusChanged (HasFocus As Boolean)
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSub2(mCallBack,mEventName & "_FocusChanged",HasFocus)
End Sub

Private Sub MyEditText_BeginEdit
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSub2(mCallBack,mEventName & "_FocusChanged",True)
End Sub

Private Sub MyEditText_EndEdit
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSub2(mCallBack,mEventName & "_FocusChanged",False)
End Sub

Private Sub MyEditText_Action
	If xui.SubExists(mCallBack,mEventName & "_EnterPressed",0) Then CallSub(mCallBack,mEventName & "_EnterPressed")
End Sub

#End region

#region Function

Private Sub ShowLine
	Dim Center As Int = mBase.Width/2
	
	OutLine.Color=TextView.TextColor
	OutLine.SetLayoutAnimated(0,Center,mBase.Height-3dip,0dip,3dip)
	OutLine.SetLayoutAnimated(ExpansionTime,5dip,mBase.Height-3dip,mBase.Width-10dip,3dip)
End Sub

Private Sub HideLine
	Dim Center As Int = mBase.Width/2
	
	OutLine.Color=TextView.TextColor
	OutLine.SetLayoutAnimated(0,5dip,mBase.Height-3dip,mBase.Width-10dip,3dip)
	
	#if B4A
		Dim Sdip As Double = (100dip/50)
		Dim EndPos As Int = (Center-5dip)/ Sdip
		Dim time As Double = ExpansionTime/ EndPos
		For  i=5 To EndPos
			OutLine.SetLayoutAnimated(time,5dip+(i*Sdip),mBase.Height-3dip,(mBase.Width-10dip)-(i*Sdip*2),3dip)
			Sleep(time)
		Next
		OutLine.SetLayoutAnimated(0,Center,mBase.Height-3dip,0dip,3dip)
	#ELSe
		OutLine.SetLayoutAnimated(ExpansionTime/2,Center,mBase.Height-3dip,0dip,3dip)
	#End If
End Sub

#End Region